#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// Lee el valor de los parametros y los asigna a las variables:
// cdat   - Nombre del archivo de datos
// dft    - factor de escala
void readParams(int argc, char **argv, char *cdat1, char *cdat2) {
    if(argc>1) strcpy(cdat1, argv[1]);
    if(argc>2) strcpy(cdat2, argv[2]);
}

// Lee un archivo de texto que contiene las
// entradas de un arreglo unidimensional, que tiene el
// formato especificado.
// Devuelve el apuntador al espacio de memoria que tiene
// la informacion y la dimension dim del arreglo
double *readVectorTxt(const char* fileName, int *dim) {
    FILE *fp = fopen(fileName, "rt");   
    double *ptr;
    int    i;
    if (!fp) return NULL;

    fscanf(fp, "%d", dim);
    double *vec = (double *) malloc( (*dim)*sizeof(double *));

    for(i=0, ptr=vec; i<*dim; i++, ptr++) {
            fscanf(fp, "%lf", ptr);
    }
    return(vec);
}

// Escritura del vector vec en el archivo cfile.
// Devuelve 0 en caso de exito y 1 si no.
int writeVector(double *vec, int dim, const char *cfile) {
    FILE       *f1 = fopen(cfile, "wb");
    
    if(!f1) return(1);
    fwrite(&dim, sizeof(int), 1, f1);
    fwrite(vec, sizeof(double), dim, f1);
    fclose(f1);
    return(0);
}

void printVector(double *vec, int dim) {
    int i; 
    for(i=0; i<dim; ++i) {
        printf("% 8.3f  ", vec[i]);
    }
    printf("\n");
}


int main(int argc, char **argv)      {
    char    cfile1[80], cfile2[80], cfile3[80];

    // Lectura de los parametros
    readParams(argc, argv, cfile1, cfile2);

    int     dim;
    double *vec = readVectorTxt(cfile1, &dim);

    printf("Lectura del archivo %s: \n", cfile1);
    printVector(vec, dim);

    printf("\nGenerando el archivo binario %s. \n", cfile2);
    writeVector(vec, dim, cfile2);

    free(vec);

    return(0);
}
// Para compilar
// gcc -o vecTxt2Bin  vecTxt2Bin.c  -lm

// Para ejecutar
// ./vecTxt2Bin vec4.txt  vec4.bin 


